#!/usr/local/bin/perl

#######################################################
#            Advanced Ranking System G2
#  
#
#  By installing and using Advanced Ranking System G2, you agree to 
#  be bound by the terms of the software license agreement that 
#  you read while your were purchasing Advanced Ranking System G2.
#  You are able to read the software license agreement again at 
#  http://www.cgi-factory.com/advranking/agreement.shtml
#  
##################################################################
#
#               COPYRIGHT NOTICE:
#
#         Copyright 1999 CGI-Factory.com 
#
#      Author:  Yutung Liu
#      web site: http://www.cgi-factory.com
#      E-Mail: cgifactory@cgi-factory.com
#      Software released date: August 11, 1999
#      The script was last modified on: September 02,1999
#
#   Advanced Ranking System G2 is protected by the copyright 
#   laws and international copyright treaties, as well as other 
#   intellectual property laws and treaties. Advanced Ranking  
#   System G2 is licensed, not sold.
#
###################################################################
$flock="1";
$alert="1";
#########
read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});
@pairs = split(/&/, $buffer);
foreach $pair (@pairs) {
        ($name, $value) = split(/=/, $pair);
        $value =~ tr/+/ /;
        $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
        $request{$name} = $value;
}
print "Content-type: text/html\n\n";

#
open (DETECT,"<pass.dat") or &decide;
if ($flock==1) {
flock DETECT, 2; 
}
@detect=<DETECT>;
close (DETECT);
if (!@detect) {
&decide;
}

sub decide {
if ($request{'action'} eq "firsttime") {
&firsttime;
exit;
}
else {
&setup;	
exit;
}
}
if ($request{'action'} eq "main_page") {
&main_page;
exit;
}
if ($request{'action'} eq "save") {
&save;
exit;
}
print <<EOF;
<HTML>
<HEAD>
<TITLE>Advanced Ranking System G2</TITLE>
</HEAD>
<BODY bgcolor="#ffffff">
<center>
<font face="Arial"><h2>Advanced Ranking System G2 configuration</h2>
Please enter your Admin Password to Login:
<form action="configur.pl" method="post">
<input type="password" name="password">
<input type="hidden" name="action" value="main_page">
<input type="submit" value="ok">
</form>
</body>
</html>
EOF
exit;


# main page
sub main_page {
&vpassword;
open (cfg, "<cfg.pl") or &error("Unable to find cfg.pl. Please make sure you have uploaded and chmoded it to \"755\"");
if ($flock==1) {
flock cfg, 2; 
} 
@cfg=<cfg>;
close(cfg);

foreach $cfg (@cfg) {
$cfg =~ s/\$.*="//g;
$cfg =~ s/";//g;

}
print <<EOF;
<html>
<head>
<title>Ranking System G2 Configurations</title>
</head>
<body bgcolor="#ffffff">
<h2>Ranking System G2 Configurations</h2>
<br>
<font color="red">*</font>= special setting variables
<br>
<form action="configur.pl" method="POST">
The name or title of you ranking list: <input type="Text" name="topsite_name" value="@cfg[0]" size="60"><br><br>
Update period(in seconds). 1800=half hour. 3600=one hour. 86400=24 hours. etc.<input type="Text" name="update_time" value="@cfg[1]"><br><br>
Time to reset all members' voting records to 0 (in seconds). 0=never. 3600=one hour. 86400=24 hours. etc.<input type="Text" name="reset_option" value="@cfg[2]"><br><br>
How many sites (entries) to be ranked?<input type="Text" name="num_show" value="@cfg[3]"><br><br>
Maximun number of sites to be displayed per page.<input type="Text" name="max_entries" value="@cfg[4]"><br><br>
Banner breaks. If your set this variable to 20. Banner break will be added between every 20 entires.<input type="Text" name="banner_break" value="@cfg[5]"><br><br>
The full system path to the directory where stores the members' data files(no back slash at the end)<input type="Text" name="data_location" value="@cfg[6]" size="60"><br><br>
The full system path to the directory where stores the backup data files.(no back slash at the end)<input type="Text" name="backup_location" value="@cfg[7]" size="60"><br><br>
The full system path to the directory where the topsites list will be created.(no back slash at the end)<input type="Text" name="create_location" value="@cfg[8]" size="60"><br><br>
The WWW path to the directory where the topsites list will be created.(no back slash at the end)<input type="Text" name="page_location" value="@cfg[9]" size="60"><br><br>
The file name of (and only) the "first" list. If you seperate the list into serveral pages, update.pl will generate the other pages as filename2.shtml, filename3.shtml and so on so on...<input type="Text" name="file_name" value="@cfg[10]"><br><br>
The WWW path to the location where a visitor will be forward after he or she has voted. For example, you can forward a visitor to thankyou.html after he or she has voted.<input type="Text" name="forward_location" value="@cfg[11]" size="60"><br><br>
The WWW path to signup.pl. Includes itself<input type="Text" name="signup_location" value="@cfg[12]" size="60"><br><br>
The WWW path to ranking.pl. Includes itself<input type="Text" name="ranking_location" value="@cfg[13]" size="60"><br><br>
The WWW path to rank-admin.pl. Includes itself<input type="Text" name="cgi" value="@cfg[14]" size="60"><br><br>
The WWW path to members.pl. Includes itself<input type="Text" name="member_cgi" value="@cfg[15]" size="60"><br><br>
The WWW path gateway.pl. Includes itself<input type="Text" name="gateway_cgi" value="@cfg[16]" size="60"><br><br>
EOF

print "Send the welcome message with html tags on it once a member has signed up <font color=\"red\">\*</font><br>";
if (@cfg[17]==1) {
print "yes<input type=\"Radio\" name=\"welcome\" value=\"1\" checked> no <input type=\"Radio\" name=\"welcome\" value=\"0\"><br><br>\n";
}
else {
print "yes<input type=\"Radio\" name=\"welcome\" value=\"1\"> no <input type=\"Radio\" name=\"welcome\" value=\"0\" checked><br><br>\n";
}	
print "Log the visitor's IP address. So the visitor won't be able to vote for himself ,herself or other people over and over again <font color=\"red\">\*</font><br>";
if (@cfg[18]==1) {
print "yes<input type=\"Radio\" name=\"ip_logging\" value=\"1\" checked> no <input type=\"Radio\" name=\"ip_logging\" value=\"0\"><br><br>\n";
}
else {
print "yes<input type=\"Radio\" name=\"ip_logging\" value=\"1\"> no <input type=\"Radio\" name=\"ip_logging\" value=\"0\" checked><br><br>\n";	
}	
print "Time period to clean the log (in seconds). 1800=half hour. 3600=one hour. 86400=24 hours. etc.<input type=\"Text\" name=\"log_clean\" value=\"@cfg[19]\"><br><br>\n";
print "Display the title of your ranking list<br>";
if (@cfg[20]==1) {
print "yes<input type=\"Radio\" name=\"show_title\" value=\"1\" checked> no <input type=\"Radio\" name=\"show_title\" value=\"0\"><br><br>\n";
}
else {
print "yes<input type=\"Radio\" name=\"show_title\" value=\"1\"> no <input type=\"Radio\" name=\"show_title\" value=\"0\" checked><br><br>\n";	
}	
print "The anti-cheating gate way. Don't change this variable once the ranking contest starts. Because you will need to notify all of your members to change the html tags for voting <font color=\"red\">\*</font><br>";
if (@cfg[21]==1) { 
print "yes<input type=\"Radio\" name=\"gate_way\" value=\"1\" checked> no <input type=\"Radio\" name=\"gate_way\" value=\"0\"><br><br>\n";
}
else {
print "yes<input type=\"Radio\" name=\"gate_way\" value=\"1\"> no <input type=\"Radio\" name=\"gate_way\" value=\"0\" checked><br><br>\n";
}	
print "Show the total number of votes that a member receives on the ranking list <font color=\"red\">\*</font><br>";
if (@cfg[22]==1) {
print "yes<input type=\"Radio\" name=\"total_votes\" value=\"1\" checked> no <input type=\"Radio\" name=\"total_votes\" value=\"0\"><br><br>\n";
}
else {
print "yes<input type=\"Radio\" name=\"total_votes\" value=\"1\"> no <input type=\"Radio\" name=\"total_votes\" value=\"0\" checked><br><br>\n";
}	
print "Show the average rating that a member receives on the ranking list <font color=\"red\">\*</font><br>";
if (@cfg[23]==1) {
print "yes<input type=\"Radio\" name=\"average_rating\" value=\"1\" checked> no <input type=\"Radio\" name=\"average_rating\" value=\"0\"><br><br>\n";
}
else {
print "yes<input type=\"Radio\" name=\"average_rating\" value=\"1\"> no <input type=\"Radio\" name=\"average_rating\" value=\"0\" checked><br><br>\n";	
}
print "Show the total score that a member receives on the ranking list <font color=\"red\">\*</font><br>";
if (@cfg[24]==1) {
print "yes<input type=\"Radio\" name=\"show_score\" value=\"1\" checked> no <input type=\"Radio\" name=\"show_score\" value=\"0\"><br><br>\n";
}
else {
print "yes<input type=\"Radio\" name=\"show_score\" value=\"1\"> no <input type=\"Radio\" name=\"show_score\" value=\"0\" checked><br><br>\n";
}	
print "Show the arrow image when an entry's position has changed <font color=\"red\">\*</font><br>";
if (@cfg[25]==1) {
print "yes<input type=\"Radio\" name=\"show_arrow\" value=\"1\" checked> no <input type=\"Radio\" name=\"show_arrow\" value=\"0\"><br><br>\n";
}
else {
print "yes<input type=\"Radio\" name=\"show_arrow\" value=\"1\"> no <input type=\"Radio\" name=\"show_arrow\" value=\"0\" checked><br><br>\n";
}	
print "The WWW Path to the upward arrow image<input type=\"Text\" name=\"up_arrow\" value=\"@cfg[26]\" size=\"60\"><br><br>\n";
print "The WWW Path to the downward arrow image<input type=\"Text\" name=\"down_arrow\" value=\"@cfg[27]\" size=\"60\"><br><br>\n";
print "Show the member's position before the last time the ranking list was updated <font color=\"red\">\*</font><br>";
if (@cfg[28]==1) {
print "yes<input type=\"Radio\" name=\"previous_position\" value=\"1\" checked> no <input type=\"Radio\" name=\"previous_position\" value=\"0\"><br><br>\n";
}
else {
print "yes<input type=\"Radio\" name=\"previous_position\" value=\"1\"> no <input type=\"Radio\" name=\"previous_position\" value=\"0\" checked><br><br>\n";
}	
print "Show the description text for a member's web site on the ranking list <font color=\"red\">\*</font><br>";
if (@cfg[29]==1) {
print "yes<input type=\"Radio\" name=\"show_description\" value=\"1\" checked> no <input type=\"Radio\" name=\"show_description\" value=\"0\"><br><br>\n";
}
else {
print "yes<input type=\"Radio\" name=\"show_description\" value=\"1\"> no <input type=\"Radio\" name=\"show_description\" value=\"0\" checked><br><br>\n";
}
print "Turn this variable off, if your ranking list is for the latest music, the products of your company, or anything that doesn't need the URL to be showed <font color=\"red\">\*</font><br>";
if (@cfg[30]==1) {
print "yes<input type=\"Radio\" name=\"show_url\" value=\"1\" checked> no <input type=\"Radio\" name=\"show_url\" value=\"0\"><br><br>\n";
}
else {
print "yes<input type=\"Radio\" name=\"show_url\" value=\"1\"> no <input type=\"Radio\" name=\"show_url\" value=\"0\" checked><br><br>\n";
}
print "Open the links on the list in new window? <font color=\"red\">\*</font><br>";
if (@cfg[31]==1) {
print "yes<input type=\"Radio\" name=\"new_window\" value=\"1\" checked> no <input type=\"Radio\" name=\"new_window\" value=\"0\"><br><br>\n";
}
else {
print "yes<input type=\"Radio\" name=\"new_window\" value=\"1\"> no <input type=\"Radio\" name=\"new_window\" value=\"0\" checked><br><br>\n";
}
print "The width of the list as the percentage of the whole browser<input type=\"Text\" name=\"width\" value=\"@cfg[32]\" size=\"3\">%<br><br>\n";
print "Show the time that the ranking list was updated<br>";
if (@cfg[33]==1) {
print "yes<input type=\"Radio\" name=\"show_update_time\" value=\"1\" checked> no <input type=\"Radio\" name=\"show_update_time\" value=\"0\"><br><br>\n";
}
else {
print "yes<input type=\"Radio\" name=\"show_update_time\" value=\"1\"> no <input type=\"Radio\" name=\"show_update_time\" value=\"0\" checked><br><br>\n";
}	
print "Let your visitors to be able to vote while they are view the list? (if you click on yes, you can choose to use a text link or voting box at the last variable on this page)<font color=\"red\">\*</font><br>";
if (@cfg[34]==1) {
print "yes<input type=\"Radio\" name=\"visitor_vote\" value=\"1\" checked> no <input type=\"Radio\" name=\"visitor_vote\" value=\"0\"><br><br>\n";
}
else {
print "yes<input type=\"Radio\" name=\"visitor_vote\" value=\"1\"> no <input type=\"Radio\" name=\"visitor_vote\" value=\"0\" checked><br><br>\n";
}	
print "The color of the title bars<input type=\"Text\" name=\"bar_color\" value=\"@cfg[35]\" size=\"10\"><br><br>\n";
print "The color of the ranking number bars<input type=\"Text\" name=\"rank_color\" value=\"@cfg[36]\" size=\"10\"><br><br>\n";
print "The color of the ranking number text<input type=\"Text\" name=\"rank_text_color\" value=\"@cfg[37]\" size=\"10\"><br><br>\n";
print "The color of the text inside the title bars<input type=\"Text\" name=\"bar_text_color\" value=\"@cfg[38]\" size=\"10\"><br><br>\n";
print "The color of the text inside the ranking list<input type=\"Text\" name=\"list_text_color\" value=\"@cfg[39]\" size=\"10\"><br><br>\n";
print "Your email address. A back slash in front of \"\@\" is requried<input type=\"Text\" name=\"youremail\" value=\"@cfg[40]\" size=\"40\"><br><br>\n";
print "The full system path to the mail program on your server<input type=\"Text\" name=\"mail_prog\" value=\"@cfg[41]\" size=\"40\"><br><br>\n";
print "Send the alert mail to you when someone enters the wrong password for the admin script<br>";
if (@cfg[42]==1) {
print "yes<input type=\"Radio\" name=\"alert\" value=\"1\" checked> no <input type=\"radio\" name=\"alert\" value=\"0\"><br><br>\n";
}
else {
print "yes<input type=\"Radio\" name=\"alert\" value=\"1\"> no <input type=\"radio\" name=\"alert\" value=\"0\" checked><br><br>\n";
}	
print "File locking. Don't turn it off unless your server has trouble using file locking<br>";
if (@cfg[43]==1) {
print "yes<input type=\"Radio\" name=\"flock\" value=\"1\" checked> no <input type=\"Radio\" name=\"flock\" value=\"0\"><br><br>\n";
}
else {
print "yes<input type=\"Radio\" name=\"flock\" value=\"1\"> no <input type=\"Radio\" name=\"flock\" value=\"0\" checked><br><br>\n";
}
print "The size of the text in the list(leave this field blank if you don't want to specify any)<input type=\"Text\" name=\"text_size\" value=\"@cfg[44]\"><br><br>\n";
print "The font face in the list(leave this field blank if you don't want to specify any)<input type=\"Text\" name=\"font_face\" value=\"@cfg[45]\"><br><br>\n";
print "Rank the members (entries) base on the <font color=\"red\">\*</font><br>";
if (@cfg[46]==3) {
print "total score<input type=\"Radio\" name=\"rank_option\" value=\"1\"> average rating<input type=\"Radio\" name=\"rank_option\" value=\"2\"> total number of votes<input type=\"Radio\" name=\"rank_option\" value=\"3\" checked><br><br>\n";
}
elsif (@cfg[46]==2) {
print "total score<input type=\"Radio\" name=\"rank_option\" value=\"1\"> average rating<input type=\"Radio\" name=\"rank_option\" value=\"2\" checked> total number of votes<input type=\"Radio\" name=\"rank_option\" value=\"3\"><br><br>";
}
else {
print "total score<input type=\"Radio\" name=\"rank_option\" value=\"1\" checked> average rating<input type=\"Radio\" name=\"rank_option\" value=\"2\"> total number of votes<input type=\"Radio\" name=\"rank_option\" value=\"3\"><br><br>";
}
print "If you want to let your visitors be able to vote when they see the list, do you want to use a voting box or text link? <font color=\"red\">\*</font><br>";
if (@cfg[47]==1) {
print "voting box<input type=\"Radio\" name=\"box\" value=\"1\" checked> text link<input type=\"Radio\" name=\"box\" value=\"2\"><br><br>\n";
}
else {
print "voting box<input type=\"Radio\" name=\"box\" value=\"1\"> text link<input type=\"Radio\" name=\"box\" value=\"2\" checked><br><br>";
}
print "<input type=\"hidden\" name=\"password\" value=\"$request{'password'}\">\n";
print "<input type=\"hidden\" name=\"action\" value=\"save\">\n";
print "<input type=\"submit\" value=\"Modify\"></form>\n";
print "<form action=\"rank-admin.pl\" method=\"post\">";
print "<input type=\"hidden\" name=\"action\" value=\"main_page\">";
print "<input type=\"hidden\" name=\"password\" value=\"$request{'password'}\">";
print "<input type=\"submit\" value=\"Dont' save changes. Back to the admin main page\">";
print "</form>";
print "<font size=\"-1\"><b>Warning: Please close your browser if you want to log off.</b><br>";
print "Copyright 1999 CGI-Factory.com</font>";
print "</body></html>";

exit;

####### save change

sub save {
&vpassword;	
	
open (cfg, ">cfg.pl") or &error("Unable to write to cfg.pl. Please make sure you have chmoded it to \"755\"(chmod it to \"777\" if it still doesn't work)");
if ($flock==1) {
flock cfg, 2; 
} 
print cfg "\$topsite_name=\"$request{'topsite_name'}\"\;\n";
print cfg "\$update_time=\"$request{'update_time'}\"\;\n";
print cfg "\$reset_option=\"$request{'reset_option'}\"\;\n";
print cfg "\$num_show=\"$request{'num_show'}\"\;\n";
print cfg "\$max_entries=\"$request{'max_entries'}\"\;\n";
print cfg "\$banner_break=\"$request{'banner_break'}\"\;\n";
print cfg "\$data_location=\"$request{'data_location'}\"\;\n";
print cfg "\$backup_location=\"$request{'backup_location'}\"\;\n";
print cfg "\$create_location=\"$request{'create_location'}\"\;\n";
print cfg "\$page_location=\"$request{'page_location'}\"\;\n";
print cfg "\$file_name=\"$request{'file_name'}\"\;\n";
print cfg "\$forward_location=\"$request{'forward_location'}\"\;\n";
print cfg "\$signup_location=\"$request{'signup_location'}\"\;\n";
print cfg "\$ranking_location=\"$request{'ranking_location'}\";\n";
print cfg "\$cgi=\"$request{'cgi'}\"\;\n";
print cfg "\$member_cgi=\"$request{'member_cgi'}\"\;\n";
print cfg "\$gateway_cgi=\"$request{'gateway_cgi'}\"\;\n";
print cfg "\$welcome=\"$request{'welcome'}\"\;\n";
print cfg "\$ip_logging=\"$request{'ip_logging'}\"\;\n";
print cfg "\$log_clean=\"$request{'log_clean'}\"\;\n";
print cfg "\$show_title=\"$request{'show_title'}\"\;\n";
print cfg "\$gate_way=\"$request{'gate_way'}\"\;\n";
print cfg "\$total_votes=\"$request{'total_votes'}\"\;\n";
print cfg "\$average_rating=\"$request{'average_rating'}\"\;\n";
print cfg "\$show_score=\"$request{'show_score'}\"\;\n";
print cfg "\$show_arrow=\"$request{'show_arrow'}\"\;\n";
print cfg "\$up_arrow=\"$request{'up_arrow'}\"\;\n";
print cfg "\$down_arrow=\"$request{'down_arrow'}\"\;\n";
print cfg "\$previous_position=\"$request{'previous_position'}\"\;\n";
print cfg "\$show_description=\"$request{'show_description'}\"\;\n";
print cfg "\$show_url=\"$request{'show_url'}\"\;\n";
print cfg "\$new_window=\"$request{'new_window'}\"\;\n";
print cfg "\$width=\"$request{'width'}\"\;\n";
print cfg "\$show_update_time=\"$request{'show_update_time'}\"\;\n";
print cfg "\$visitor_vote=\"$request{'visitor_vote'}\"\;\n";
print cfg "\$bar_color=\"$request{'bar_color'}\"\;\n";
print cfg "\$rank_color=\"$request{'rank_color'}\"\;\n";
print cfg "\$rank_text_color=\"$request{'rank_text_color'}\"\;\n";
print cfg "\$bar_text_color=\"$request{'bar_text_color'}\"\;\n";
print cfg "\$list_text_color=\"$request{'list_text_color'}\"\;\n";
print cfg "\$youremail=\"$request{'youremail'}\"\;\n";
print cfg "\$mail_prog=\"$request{'mail_prog'}\"\;\n";
print cfg "\$alert=\"$request{'alert'}\"\;\n";
print cfg "\$flock=\"$request{'flock'}\"\;\n";
print cfg "\$text_size=\"$request{'text_size'}\"\;\n";
print cfg "\$font_face=\"$request{'font_face'}\"\;\n";
print cfg "\$rank_option=\"$request{'rank_option'}\"\;\n";
print cfg "\$box=\"$request{'box'}\"\;\n";
close(cfg);
	
print "The new configuration has been saved. If anything doesn't work out, you can run configur.pl again to change the setting again.\n";
print "<form action=\"rank-admin.pl\" method=\"post\">";
print "<input type=\"hidden\" name=\"action\" value=\"main_page\">";
print "<input type=\"hidden\" name=\"password\" value=\"$request{'password'}\">";
print "<input type=\"submit\" value=\"Back to the admin main page\">";
print "</form>";
print "<font size=\"-1\"><b>Warning: Please close your browser if you want to log off.</b><br>";
print "Copyright 1999 CGI-Factory.com</font>";
exit;
}	
###### password

sub vpassword{
	
open (PASS,"pass.dat") or &error("Unable to open the password file"); 
if ($flock==1) {
flock PASS, 2; 
}
$pass = <PASS>;
close(PASS);
$request{'password'}=~ tr/A-Z/a-z/;
$pass2 = crypt($request{'password'}, "MM");
unless ($pass eq "$pass2") {
$timenow=localtime();
print "<h2>Incorrect login</h2>";
print "The password you entered is incorrect.<br>";
print "The following information has been sent to the webmaster of the web site for security reasons.<br>";
print "<ul>Your IP Address:$ENV{'REMOTE_HOST'}</ul>";
print "<ul>Password your entered: $request{'password'}</ul>";
print "<ul>Time: $timenow</ul>";
print "</body></html>";
 
if ($alert==1) {       

open (MAIL, "|$mail_prog") or &error("Unable to open the mail program");
print MAIL "To: $youremail\n";
print MAIL "From: $youremail\n";
print MAIL "Subject: bad password\n";
print MAIL "someone entered the wrong password for entering the admin script.\n";
print MAIL "Here is information:\n\n";
print MAIL "IP Address: $ENV{'REMOTE_ADDR'}\n";
print MAIL "Password: $request{'password'}\n";
print MAIL "$timenow\n";
close(MAIL);
exit;
}      
exit;
}
}	
####
sub setup {

print "This is the first time you run this script or you may have deleted the password file by mistake.\n";
print "Please set up your admin password:<br>\n";
print "<form action=\"configur.pl\" method=\"post\">\n";
print "Password:<input type=\"text\" name=\"password1\"><br>\n";
print "Enter the passward again:<input type=\"text\" name=\"password2\">\n";
print "<input type=\"hidden\" name=\"action\" value=\"firsttime\">\n";
print "<input type=\"submit\" value=\"OK\"></form>";
exit;

}

sub firsttime {
	
if ($request{'password1'} eq "" and !$request{'password1'}) {
print "Please don't leave the password field blank!";
exit;
}
	
if ($request{'password2'} eq "" and !$request{'password2'}) {
print "Please don't leave the password field blank!";
exit;
}

if ($request{'password1'} ne "$request{'password2'}" and $request{'password1'} != $request{'password2'}){
print "You entered two different passwords. Please try again!";
exit;
}

$request{'password1'}=~ tr/A-Z/a-z/; 
$password = crypt($request{'password1'}, "MM");	
    
open (PASSWORD, ">pass.dat") or &error("unable to create the password file");
    
if ($flock==1) {
flock PASSWORD, 2; 
}
print PASSWORD "$password";
close (PASSWORD);
print "<h2>New password is saved. Please reload this page to continue setting up the ranking system.</h2>\n";
exit;
}

}

#####error
sub error {
print "<h2>An error has occured</h2> The error is $_[0]<br>\n";	
print "$!\n<br><br>";
print "Please contact the webmaster of this web site if you keep getting this message.";	
exit;	
}
 
	
	
	

