#!/usr/local/bin/perl

#######################################################
#            Advanced Ranking System G2
#  
#
#  By installing and using Advanced Ranking System G2, you agree to 
#  be bound by the terms of the software license agreement that 
#  you read while your were purchasing Advanced Ranking System G2.
#  You are able to read the software license agreement again at 
#  http://www.cgi-factory.com/advranking/agreement.shtml
#  
##################################################################
#
#               COPYRIGHT NOTICE:
#
#         Copyright 1999 CGI-Factory.com 
#
#      Author:  Yutung Liu
#      web site: http://www.cgi-factory.com
#      E-Mail: cgifactory@cgi-factory.com
#      Software released date: August 11, 1999
#      The script was last modified on: September 02,1999
#
#   Advanced Ranking System G2 is protected by the copyright 
#   laws and international copyright treaties, as well as other 
#   intellectual property laws and treaties. Advanced Ranking  
#   System G2 is licensed, not sold.
#
###################################################################
require "cfg.pl";

if ($ENV{'REQUEST_METHOD'} eq 'GET') {
@pairs = split(/&/, $ENV{'QUERY_STRING'});
}
elsif ($ENV{'REQUEST_METHOD'} eq 'POST') {
read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});
@pairs = split(/&/, $buffer);
}
else {
&error('request_method');
}
foreach $pair (@pairs) {
($name, $value) = split(/=/, $pair);
$name =~ tr/+/ /;
$name =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
$value =~ tr/+/ /;
$value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
$value =~ s/\n/\s/g;
if ($name && $value) { $request{$name} = $value; }
}

print "Content-type: text/html\n\n";

if (!$request{'member'}) {
&notfound;
}
	
if ($request{'member'}=~ tr/;<>*|`&$!#()[]{}:'"//) {
&header;
print "<h2>Action Canceled</h2>\n";
print "Please don't use weird symbols.<br>\n";
&footer;
exit;
}
open (members, "<$data_location/$request{'member'}.dat") or &notfound;
if ($flock==1) {
flock members, 2; 
}
@members=<members>;
close(members);

&header;
print "<h2>Welcome to $topsite_name</h2>\n";
print "Please select a score for <b>@members[4]</b> then click on the button below to continue.<br>\n";
print "<br>Score Rating: 10= best. 1=worst<br>\n"; 
print "<form action=\"$ranking_location\" method=\"post\">\n";
print "<input type=\"hidden\" name=\"member\" value=\"$request{'member'}\">\n";
$count=1;
for ($count; $count<=10; $count++) {
print "<input type=\"radio\" name =\"score\" value=\"$count\"";
if ($count==$request{'score'}) {
print " checked";
}
print ">$count<br>\n";
}
print "<br>";
print "<input type=\"submit\" value=\"Continue\">\n";
print "</form>\n";
&footer;

exit;

####not found
sub notfound {
&header;
print "<h2>Member not found</h2>";
print "Sorry, we are not able to find this member (Id: $member) in our database.<br>\n";
print "However, you can still view the ranking list by clicking <a href=\"$page_location/$file_name\">here</a>.<br>\n";
&footer;
exit;	

}

######################header input

sub header {
open (header, "<gheader.txt") or &error("Unable to open the header file");
if ($flock==1) {
flock header, 2; 
}
@header=<header>;
close(header);
foreach $header(@header) {
print "$header";
}
}
####################footer input

sub footer {
open (footer, "<gfooter.txt") or &error("Unable to open the footer file");
if ($flock==1) {
flock footer, 2; 
}
@footer=<footer>;
close(footer);
foreach $footer(@footer) {
print "$footer";
}
}

#####error
sub error {
print "<h2>An error has occured</h2> The error is $_[0]<br>\n";	
print "$!\n<br><br>";
print "Please contact the webmaster of this web site if you keep getting this message.";	
exit;	
}
 