#!/usr/local/bin/perl
#######################################################
#            Advanced Ranking System G2
#  
#
#  By installing and using Advanced Ranking System G2, you agree to 
#  be bound by the terms of the software license agreement that 
#  you read while your were purchasing Advanced Ranking System G2.
#  You are able to read the software license agreement again at 
#  http://www.cgi-factory.com/advranking/agreement.shtml
#  
##################################################################
#
#               COPYRIGHT NOTICE:
#
#         Copyright 1999 CGI-Factory.com 
#
#      Author:  Yutung Liu
#      web site: http://www.cgi-factory.com
#      E-Mail: cgifactory@cgi-factory.com
#      Software released date: August 11, 1999
#      The script was last modified on: October 07,1999
#
#   Advanced Ranking System G2 is protected by the copyright 
#   laws and international copyright treaties, as well as other 
#   intellectual property laws and treaties. Advanced Ranking  
#   System G2 is licensed, not sold.
#
###################################################################

require "cfg.pl";

read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});
@pairs = split(/&/, $buffer);
foreach $pair (@pairs) {
        ($name, $value) = split(/=/, $pair);
        $value =~ tr/+/ /;
        $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
        $value =~ s/\n/ /g;

        $request{$name} = $value;

if ($value=~ tr/;<>*|`&$!#()[]{}:'"//) {
print "Content-type: text/html\n\n";
print "Security Alert! Action canceled.<br>\n";
print "Please don't use weird symbols\n";
exit;
}
}

$time=time();

if ($gate_way==1) {
unless ($ENV{'HTTP_REFERER'}=~ /$gateway_cgi/i) { 
print "Content-type: text/html\n\n";
&h;
print "<h2>Voting Disallowed</h2>";
print "Sorry, the gateway function is enable. You must vote through the gateway. Please contact";
print " the webmaster of this web site if you keep getting this message.<br>";
&f;
exit;
}	
}

if (!$request{'member'}) {
&notfound;
exit;
}
$member=$request{'member'};
open (members, "<$data_location/$member.dat") or &notfound;
if ($flock==1) {
flock members, 2; 
}
@members=<members>;
close(members);
if ($request{'score'}<1 or $request{'score'}>10) {
print "Content-type: text/html\n\n";
&h;
print "<h2>Invalid Score</h2>";
print "Sorry, the ranking system only accepts scores from 1 - 10.<br>\n";
print "However, you can still view the ranking list by clicking <a href=\"$page_location/$file_name\">here</a>.<br>\n";
&f;
exit;	
}
if ($ip_logging == 1) {
if (!$ENV{'REMOTE_HOST'}) {
$visitor=$ENV{'REMOTE_ADDR'};
}
else {
$visitor=$ENV{'REMOTE_HOST'};
}
open (ip, "<ip.txt") or &error("Unable to open the data file- ip.txt");
if ($flock==1) {
flock ip, 2; 
}
@ip=<ip>;
close(ip);
foreach $ip(@ip) {

chomp($ip);

@dip=split(/|/, $ip);
if ($ip eq "$visitor|$request{'member'}") {
print "Content-type: text/html\n\n";
&h;
print "<h2>Voting Disallowed</h2>";
print "Our log shows that you have voted already. There is no need to vote again.<br>\n";
&f;
&log_time;
exit;
}
}

open (wip, ">>ip.txt") or &error("Unable to open the data file- ip.txt");
if ($flock==1) {
flock wip, 2; 
}
print wip "$visitor|$request{'member'}\n";
close(wip);
&log_time;
}

##clean log	
sub log_time {
open (iptime, "<iptime.txt") or &error("Unable to open the data file- iptime.txt");
if ($flock==1) {
flock iptime, 2; 
}
$iptime=<iptime>;
close(iptime);

$logtime=$time-$iptime;

if ($logtime>$log_clean) {
open (wiptime, ">iptime.txt") or &error("Unable to write to the data file- iptime.txt");
if ($flock==1) {
flock wiptime, 2; 
}
print wiptime "$time";
close(wiptime);

open (cip, ">ip.txt") or &error("Unable to write to the file- ip.txt");
if ($flock==1) {
flock cip, 2; 
}
close(cip);
}
}	
#record hit.
$hit=@members[0];
$score=@members[1];

$hit++;
$score=$score+$request{'score'};
$rate=sprintf("%.2f", $score/$hit);

open (members, ">$data_location/$member.dat") or &error("Unable to create the data file");

if ($flock==1) {

flock members, 2; 

}

print members "$hit\n";
print members "$score\n";
print members "$rate\n";
print members @members[3];
print members @members[4];
print members @members[5];
print members @members[6];
print members @members[7];
print members @members[8];
print members @members[9];
print members "1\n";

close(members);

#check time
open (ptime, "<time.txt")  or &error("Unable to open the counting file");
if ($flock==1) {
flock ptime, 2; 
}
@ptime=<ptime>;
close(ptime);
$diff=$time-@ptime[0];
if ($diff>=$update_time) {
require "update.pl";	
}
print "Location:$forward_location\n\n";
exit;

####not found
sub notfound {
print "Content-type: text/html\n\n";
&h;
print "<h2>Member not found</h2>";
print "Sorry, we are not able to find this member (Id: $member) in our database.<br>\n";
print "However, you can still view the ranking list by clicking <a href=\"$page_location/$file_name\">here</a>.<br>\n";
&f;
exit;	

}
######################header input

sub h {
open (h, "<rheader.txt") or &error("Unable to open the rheader file");
if ($flock==1) {
flock h, 2; 
}
@h=<h>;
close(h);
print @h;
}
####################footer input

sub f {
open (f, "<rfooter.txt") or &error("Unable to open the rfooter file");
if ($flock==1) {
flock f, 2; 
}
@f=<f>;
close(f);
print @f;
}
#####error
sub error {
print "Content-type: text/html\n\n";
print "<h2>An error has occured</h2> The error is $_[0]<br>\n";	
print "$!\n<br><br>";
print "Please contact the webmaster of this web site if you keep getting this message.";	
exit;	
}
 